# Script to add Zeppelin public key to users authorized key file
UNAME=""
if [ "$UNAME" == "" ];then
  echo "assign a user name to UNAME in script"
else
  if [ ! -d /home/"$UNAME" ];then
    echo "No user with that name"
    exit
  fi
  echo User Name: $UNAME
fi
ZEPPPATH=/home/zeppelin
PUBKEY=id_ecdsa.pub
# test if zeppelin user exists
if [ -d $ZEPPPATH ]; then
  # test if pub key exists
  if  [ ! -f "$ZEPPPATH"/.ssh/"$PUBKEY" ]; then
    # create key
    su - zeppelin -c "/etc/warewulf/.Limulus/generate-ssh-keys.sh"
  fi
  # copy pub key to users .ssh
  if [ ! -d /home/"$UNAME"/.ssh ];then
    mkdir /home/"$UNAME"/.ssh
  fi
  # add the pub key to the authorized_keys file
  cat "$ZEPPPATH"/.ssh/"$PUBKEY" >> /home/"$UNAME"/.ssh/authorized_keys
  chown -R $UNAME:$UNAME /home/$UNAME/.ssh
  echo "Complete"
else
  echo "No Zeppelin path, no changes made"
fi
