#!/bin/bash
# Copyright (c) 2021 All Rights Reserved Basement Supercomputering
# Mon Dec 27 17:02:24 EST 2021
# Formating the HDFS disks depends on using PLEXTOR, Crucial_CT, Samsung
# as a way ot identity the SSD drives. This may change
# and require adjustment. Currently, the partition table is
# deleted, a single partion is created, the disk is formated
# as ext4.

/bin/cp /etc/fstab /etc/.limulus-fstab.orig
DISKPATH=/dev/disk/by-id
SSD1=`ls $DISKPATH|grep ata-PLEXTOR|grep -v part|grep -v PLEXTOR_PX-64M`
SSD2=`ls $DISKPATH|grep ata-Crucial_CT|grep -v part `
SSD3=`ls $DISKPATH|grep ata-Samsung|grep -v part `
SSD="$SSD1 $SSD2 $SSD3"
echo ""
echo "  WARNING  WARNING  WARNING"
echo "  =======  =======  ======="
echo "The following drives on **$HOSTNAME** will be reformatted:"
echo $SSD
echo ""
echo "This procedure is only needed when rebuilding the system."
echo "Enter 'y' to continue, all other keys quit: "
read ANS
if [ "$ANS" != "y" ]; then
  exit
fi
echo "Are you sure? Enter 'Y' to continue, all other keys quit: "
read ANS
if [ "$ANS" != "Y" ]; then
  exit
fi
echo "++ umount /hdfs1 /hdfs2 "
umount /hdfs1
umount /hdfs2
HDFSNUMBER=1
MOUNTS=""
for I in $SSD
do
FULL=`readlink $DISKPATH/$I`
DRIVE=`basename $FULL`
echo "++ Clearing partions on /dev/$DRIVE"
dd if=/dev/zero of=/dev/$DRIVE bs=512 count=1 &>/dev/null
echo "++ Making one Linux partion on /dev/$DRIVE"
#fdisk  /dev/$DRIVE <<EOF  &>/dev/null
fdisk  /dev/$DRIVE <<EOF 
n
p
1


t
83
w
EOF
echo "++ Formating /dev/"$DRIVE"1 as ext4"
mkfs.ext4 /dev/"$DRIVE"1 &>/dev/null
MOUNTS="$MOUNTS hdfs$HDFSNUMBER"
echo "/dev/"$DRIVE"1        /hdfs$HDFSNUMBER         ext4          nofail,noauto,defaults,noatime,nodiratime   1 0" >>/etc/fstab
mkdir -p /hdfs$HDFSNUMBER
let HDFSNUMBER=$HDFSNUMBER+1
done
echo "Determine UUID and change entry in /etc/fstab"
# mount and find the UUID using blkid
# Then update /etc/fstab
for M in $MOUNTS; do
  mount /$M
done
for M in $MOUNTS; do
   DEVICE=`grep $M /etc/fstab |gawk '{print $1}'`
   UUID=`blkid -s UUID -o value $DEVICE`
   echo $UUID
   sed -i "s!$DEVICE!UUID=$UUID!" /etc/fstab
   umount /$M
   mount /$M
done
echo "Current /hdfs{1,2} mounts are:"
df -h|grep hdfs
